
Redmine - Defect #9980

Cannot Read Mail From Exchange, Bad Cert.

2012-01-11 21:59 - William Roush

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Email receiving Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 1.3.0

Description

Redmine: 1.3

Ruby: 1.8.7

DB: MySQL 5.1.49

LOCAL GEMS ***

actionmailer (2.3.14)

actionpack (2.3.14)

activerecord (2.3.14)

activeresource (2.3.14)

activesupport (2.3.14)

daemon_controller (0.2.6)

fastthread (1.0.7)

passenger (3.0.11)

rack (1.4.0, 1.1.3)

rails (2.3.14)

rake (0.8.7)

Errors:

/opt/redmine/config# rake -f /opt/redmine/Rakefile redmine:email:receive_pop3 RAILS_ENV="production" host=[removed]

username=[removed] password=[removed]

(in /opt/redmine/config)

Please install RDoc 2.4.2+ to generate documentation.

rake aborted!

SSL_connect returned=1 errno=0 state=SSLv2/v3 read server hello A: unknown protocol

 /opt/redmine/config# rake -f /opt/redmine/Rakefile redmine:email:receive_imap RAILS_ENV="production" ssl=1 host=[removed]

username=[removed] password=[removed] move_on_success=success move_on_failure=failure --trace

(in /opt/redmine/config)

Please install RDoc 2.4.2+ to generate documentation.

Invoke redmine:email:receive_imap (first_time)

Invoke environment (first_time)

Execute environment

Execute redmine:email:receive_imap

rake aborted!

SSL_connect returned=1 errno=0 state=SSLv2/v3 read server hello A: unknown protocol

/usr/lib/ruby/1.8/net/imap.rb:904:in `connect'

/usr/lib/ruby/1.8/net/imap.rb:904:in `initialize'

/opt/redmine/lib/redmine/imap.rb:31:in `new'

/opt/redmine/lib/redmine/imap.rb:31:in `check'

/opt/redmine/lib/tasks/email.rake:133

/usr/lib/ruby/1.8/rake.rb:636:in `call'

/usr/lib/ruby/1.8/rake.rb:636:in `execute'

/usr/lib/ruby/1.8/rake.rb:631:in `each'

/usr/lib/ruby/1.8/rake.rb:631:in `execute'

/usr/lib/ruby/1.8/rake.rb:597:in `invoke_with_call_chain'
/usr/lib/ruby/1.8/monitor.rb:242:in `synchronize'

/usr/lib/ruby/1.8/rake.rb:590:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/rake.rb:583:in `invoke'

/usr/lib/ruby/1.8/rake.rb:2051:in `invoke_task'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2029:in `each'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:2023:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2001:in `run'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:1998:in `run'

/usr/bin/rake:28

 

So obviously it's having a bit of a struggle connecting to our TLS only Exchange server, I have two options on the exchange side, and

they both involve breaking SSL, so that is a no-go.

Just for testing, I edit /usr/lib/ruby/1.8/bet/imap.rb and force TLSv1

-896:         context = SSLContext::new()

+896:         context = SSLContext::new(:TLSv1)

And I get this:

SSL_connect returned=1 errno=0 state=SSLv3 read server hello A: wrong version number

/usr/lib/ruby/1.8/net/imap.rb:904:in `connect'

/usr/lib/ruby/1.8/net/imap.rb:904:in `initialize'

/opt/redmine/lib/redmine/imap.rb:29:in `new'

/opt/redmine/lib/redmine/imap.rb:29:in `check'

/opt/redmine/lib/tasks/email.rake:133

/usr/lib/ruby/1.8/rake.rb:636:in `call'

/usr/lib/ruby/1.8/rake.rb:636:in `execute'

/usr/lib/ruby/1.8/rake.rb:631:in `each'

/usr/lib/ruby/1.8/rake.rb:631:in `execute'

/usr/lib/ruby/1.8/rake.rb:597:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/monitor.rb:242:in `synchronize'

/usr/lib/ruby/1.8/rake.rb:590:in `invoke_with_call_chain'

/usr/lib/ruby/1.8/rake.rb:583:in `invoke'

/usr/lib/ruby/1.8/rake.rb:2051:in `invoke_task'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2029:in `each'

/usr/lib/ruby/1.8/rake.rb:2029:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:2023:in `top_level'

/usr/lib/ruby/1.8/rake.rb:2001:in `run'

/usr/lib/ruby/1.8/rake.rb:2068:in `standard_exception_handling'

/usr/lib/ruby/1.8/rake.rb:1998:in `run'

/usr/bin/rake:28

 Any ideas on why this isn't working?

History

#1 - 2012-01-11 23:48 - William Roush

Sorry, made it sound like it's a support request, it seems to be a bug in either Ruby (1.8? It may be fixed in 1.9...), or if it's behavior that can be fixed in

Redmine itself (though it seems to be part of Net::IMAP's behavior that is causing it).

#2 - 2012-02-15 16:06 - William Roush

- Status changed from New to Resolved

Configuration issue, sorry, no port specified (doesn't default to 993 when SSL is enabled).
#3 - 2012-02-15 16:19 - Etienne Massip

- Status changed from Resolved to Closed

- Resolution set to Invalid

Thanks for your feedback.
